package com.agiledeveloper

import grails.test.mixin.TestFor
import spock.lang.Specification

/**
 * See the API for {@link grails.test.mixin.web.ControllerUnitTestMixin} for usage instructions
 */
@TestFor(PersonController)
@Mock(Person)
class PersonControllerSpec extends Specification {

  def setup() {
    mockDomain(Person, [
      new Person(firstName: 'Brad', lastName: 'Walker', emailAddress: 'bw@example.com'),
      new Person(firstName: 'Sara', lastName: 'Walker', emailAddress: 'sw@example.com'),
      new Person(firstName: 'Kim', lastName: 'Wong', emailAddress: 'kw@example.com'),
      new Person(firstName: 'Shiva', lastName: 'Raj', emailAddress: 'srm@example.com')])
  }
  
  def cleanup() {
  }
  
  void "test list"() {
    def model = controller.list()
    expect:
      4 == model.people.size()
  }
  
  void "test list returns names in sorted order of last name"() {
    def model = controller.list()
    expect:
      'Raj' == model.people[0].lastName
  }
  
  void "test create"() {
    def model = controller.create()
    expect:
      null != model.person
  }
  
  void "test save good data"() {
    request.contentType = FORM_CONTENT_TYPE
    params.firstName = 'Jake'
    params.lastName = 'Johnson'
    params.emailAddress = 'jj@example.com'
    
    controller.save()
    expect:
      '/person/list' == response.redirectedUrl
      null != controller.flash.message
  }
  
  void "test save bad data"() {
    request.contentType = FORM_CONTENT_TYPE
    
    controller.save()
    expect:
      '/person/create' == view
      null != model.person
  }
}
